'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Sequence2 = require('./Sequence');

var _Sequence3 = _interopRequireDefault(_Sequence2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Loop
 *
 * Recurrent tasks
 *
 * @param {number} repeats number of repeats. 0 for infinite
 * @param {Function} repeat function to be called on repeat
 * @param {Function} recover function to be called on recover
 */
var Loop = function (_Sequence) {
  _inherits(Loop, _Sequence);

  /**
   * Loop constructor
   *
   * @param {number} repeats number of repeats. 0 for infinite
   * @param {Function} repeat function to be called on repeat
   * @param {Function} recover function to be called on recover
   */
  function Loop(repeats, repeat, recover) {
    _classCallCheck(this, Loop);

    var _this = _possibleConstructorReturn(this, (Loop.__proto__ || Object.getPrototypeOf(Loop)).call(this, repeat, recover));

    _this._repeats = repeats === undefined ? 0 : repeats;
    _this._repeat = 0;
    _this._looped = [];
    return _this;
  }

  /**
   * Complete
   *
   * Runs complete task
   *
   * @protected
   */


  _createClass(Loop, [{
    key: '_complete',
    value: function _complete() {
      var _this2 = this;

      _get(Loop.prototype.__proto__ || Object.getPrototypeOf(Loop.prototype), '_complete', this).call(this);

      if (!this._stopped) {
        if (this._repeats === 0 || ++this._repeat < this._repeats) {
          while (this._looped.length > 0) {
            this.tasks.push(this._looped.shift());

            this._chainTask(this.tasks[this.tasks.length - 1]);
          }

          setTimeout(function () {
            return _this2.run();
          }, 0);
        }
      }
    }

    /**
     * Gets next task from the loop
     *
     * @return {Task} task next task
     * @protected
     */

  }, {
    key: '__next',
    get: function get() {
      var current = _get(Loop.prototype.__proto__ || Object.getPrototypeOf(Loop.prototype), '__next', this);

      if (this._looped.length === 0 || this._looped[this._looped.length - 1] !== current) {
        this._looped.push(current);
      }

      return current;
    }

    /**
     * Gets the passed task(s)
     *
     * @return {Array<Task>} task passed task(s)
     */

  }, {
    key: 'passed',
    get: function get() {
      return undefined;
    }
  }]);

  return Loop;
}(_Sequence3.default);

exports.default = Loop;