'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Map2 = require('./Map');

var _Map3 = _interopRequireDefault(_Map2);

var _Match = require('./Match');

var _Match2 = _interopRequireDefault(_Match);

var _TimeoutTask = require('../tasks/TimeoutTask');

var _TimeoutTask2 = _interopRequireDefault(_TimeoutTask);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Map for TimeoutTasks
 *
 * Maps the default ways to get a TimeoutTask
 */
var TimeoutMap = function (_Map) {
  _inherits(TimeoutMap, _Map);

  function TimeoutMap() {
    _classCallCheck(this, TimeoutMap);

    return _possibleConstructorReturn(this, (TimeoutMap.__proto__ || Object.getPrototypeOf(TimeoutMap)).apply(this, arguments));
  }

  _createClass(TimeoutMap, [{
    key: 'match',

    /**
     * Match argument with a specific TimeoutTask
     *
     * @param {number} timeout timeout in ms
     * @param {Function} run function to be called on run
     * @param {Function} complete function to be called on complete
     * @param {Function} recover function to be called on recover
     * @return {Match} match
     */
    value: function match() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (args.length === 4 && typeof args[0] === 'number' && typeof args[1] === 'function' && typeof args[2] === 'function' && typeof args[3] === 'function') {
        return new _Match2.default(new (Function.prototype.bind.apply(_TimeoutTask2.default, [null].concat(args)))());
      } else if (args.length === 3 && typeof args[0] === 'number' && typeof args[1] === 'function' && typeof args[2] === 'function') {
        return new _Match2.default(new (Function.prototype.bind.apply(_TimeoutTask2.default, [null].concat(args)))());
      } else if (args.length === 2 && typeof args[0] === 'number' && typeof args[1] === 'function') {
        return new _Match2.default(new (Function.prototype.bind.apply(_TimeoutTask2.default, [null].concat(args)))());
      } else if (args.length === 1 && typeof args[0] === 'number') {
        return new _Match2.default(new (Function.prototype.bind.apply(_TimeoutTask2.default, [null].concat(args)))());
      } else {
        return undefined;
      }
    }
  }]);

  return TimeoutMap;
}(_Map3.default);

exports.default = TimeoutMap;