'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Map2 = require('./Map');

var _Map3 = _interopRequireDefault(_Map2);

var _Match = require('./Match');

var _Match2 = _interopRequireDefault(_Match);

var _TriggerTask = require('../tasks/TriggerTask');

var _TriggerTask2 = _interopRequireDefault(_TriggerTask);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Map for TriggerTask
 *
 * Maps the default ways to get a TriggerTask
 */
var TriggerMap = function (_Map) {
  _inherits(TriggerMap, _Map);

  function TriggerMap() {
    _classCallCheck(this, TriggerMap);

    return _possibleConstructorReturn(this, (TriggerMap.__proto__ || Object.getPrototypeOf(TriggerMap)).apply(this, arguments));
  }

  _createClass(TriggerMap, [{
    key: 'match',

    /**
     * Match argument with a specific TriggerTask
     *
     * @param {Function} complete function to be called on complete
     * @param {boolean} marker false marks a trigger task
     * @return {Match} match
     */
    value: function match() {
      if (arguments.length === 2 && typeof (arguments.length <= 0 ? undefined : arguments[0]) === 'function' && (arguments.length <= 1 ? undefined : arguments[1]) === false) {
        return new _Match2.default(new _TriggerTask2.default(arguments.length <= 0 ? undefined : arguments[0]));
      } else if (arguments.length === 0) {
        return new _Match2.default(new _TriggerTask2.default(), 0);
      } else {
        return undefined;
      }
    }
  }]);

  return TriggerMap;
}(_Map3.default);

exports.default = TriggerMap;