'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Task2 = require('./Task');

var _Task3 = _interopRequireDefault(_Task2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * AsyncTask
 *
 * Executes run and does not complete automatically.
 * Need manual call of complete() method.
 * Useful for triggers.
 *
 * Similar with TriggerTask, but with full set of run, complete and recover.
 * In run method first parameter will be complete callback, second self and
 * ...args to follow. Does not care what run returns.
 *
 * @example run = (complete, self, ...args) => { complete(); }
 *
 * @param {Function} run function to be called on run
 * @param {Function} complete function to be called on complete
 * @param {Function} recover function to be called on recover
 */
var AsyncTask = function (_Task) {
  _inherits(AsyncTask, _Task);

  /**
   * AsyncTask constructor
   *
   * @param {Function} run function to be called on run
   * @param {Function} complete function to be called on complete
   * @param {Function} recover function to be called on recover
   */
  function AsyncTask(run, complete, recover) {
    _classCallCheck(this, AsyncTask);

    return _possibleConstructorReturn(this, (AsyncTask.__proto__ || Object.getPrototypeOf(AsyncTask)).call(this, run, complete, recover));
  }

  /**
   * Runs a task
   *
   * Executes the run function if defined. All arguments will be
   * passed to it.
   *
   * @param {any} args any arguments
   */


  _createClass(AsyncTask, [{
    key: 'run',
    value: function run() {
      this._running = true;

      if (this._run !== undefined) {
        try {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          this._run.apply(this, [this.complete.bind(this), this].concat(args));
        } catch (error) {
          this._exceptions.run = error;
        }
      }
    }
  }]);

  return AsyncTask;
}(_Task3.default);

exports.default = AsyncTask;